    Program f07wefe

!     F07WEF Example Program Text

!     Mark 24 Release. NAG Copyright 2012.

!     .. Use Statements ..
      Use nag_library, Only: dpftrf, dpftrs, nag_wp, x04caf
!     .. Implicit None Statement ..
      Implicit None
!     .. Parameters ..
      Integer, Parameter               :: nin = 5, nout = 6
!     .. Local Scalars ..
      Integer                          :: i, ifail, info, ldb, lena, n, nrhs
      Character (1)                    :: transr, uplo
!     .. Local Arrays ..
      Real (Kind=nag_wp), Allocatable  :: a(:), b(:,:)
!     .. Executable Statements ..
      Write (nout,*) 'F07WEF Example Program Results'
!     Skip heading in data file
      Read (nin,*)
      Read (nin,*) n, nrhs, uplo, transr

      lena = n*(n+1)/2
      ldb = n
      Allocate (a(lena),b(ldb,nrhs))

!     Read A and B from data file
      Read (nin,*) a(1:lena)
      Do i = 1, n
        Read (nin,*) b(i,1:nrhs)
      End Do

!     Factorize A
      info = 0
!     The NAG name equivalent of dpftrf is f07wdf
      Call dpftrf(transr,uplo,n,a,info)

      Write (nout,*)
      Flush (nout)
      If (info==0) Then

!       Compute solution
!       The NAG name equivalent of dpftrs is f07wef
        Call dpftrs(transr,uplo,n,nrhs,a,b,ldb,info)

!       Print solution
        ifail = 0
        Call x04caf('General',' ',n,nrhs,b,ldb,'Solution(s)',ifail)

      Else
        Write (nout,*) 'A is not positive definite'
      End If

    End Program f07wefe
